//
// SoftPixel Engine - Tutorial11(Animation) - (12.3.2008)
//

#include <SoftPixelEngine.hpp>

using namespace sp;

#include "../common.hpp"

int main()
{
    
    // The folowing lines should not surpriseful
    
    SoftPixelDevice* spDevice = createDevice(
        ChooseRenderer(), dim::size2di(640, 480), 32, "Tutorial11 (Animation)"
    );
    
    video::VideoDriver* spDriver = spDevice->getVideoDriver();
    scene::SceneManager* spSmngr = spDevice->getSceneManager();
    UserControl* spControl = spDevice->getUserControl();
    
    scene::anim::Animator* spAnim8or = spSmngr->getAnimator();
    
    spDevice->setWindowTitle(
        spDevice->getWindowTitle() + io::stringc(" [ ") + spDriver->getVersion() + io::stringc(" ]")
    );
    
    scene::Camera* cam = spSmngr->createCamera();
    
    video::Texture* tex = spDriver->loadTexture("model/bird.pcx");
    video::Texture* texbg = spDriver->loadTexture("model/bg.JPG");
    
    scene::Entity* obj = spSmngr->loadModel("model/bird.md2");
    scene::anim::Animation* anim = spAnim8or->getAnimation(obj);
    
    obj->addTexture(tex);
    obj->setPosition(dim::vector3df(-0.2, -0.5, 1.5));
    obj->setScale(dim::vector3df(0.001f));
    obj->setRotation(dim::vector3df(-25, 25, 0));
    
    anim->doAnimate(scene::anim::ANIM_LOOP);
    
    spDriver->setClearColor(video::color(255));
    spDevice->setResizeMode(false);
    
    while (spDevice->updateEvent() && !spControl->isKeyPressed(KEY_ESCAPE))
    {
        spDriver->clearBuffers();
        
        spDriver->beginDrawing2D();
        spDriver->draw2DImage(texbg, dim::rect2di(0, 0, 640, 480), dim::rect2df(0, 0, 1, 1), video::color(255, 255, 255, 200));
        spDriver->endDrawing2D();
        
        spAnim8or->updateAnimations();
        spSmngr->renderScene();
        
        spDriver->flipBuffers();
    }
    
    deleteDevice();
    
    return 0;
}


// Sprite functions




// ======================================================
