//
// SoftPixel Engine - Tutorial16(GUI) - (17.3.2008)
//

#include <SoftPixelEngine.hpp>

using namespace sp;

#include "../common.hpp"

int main()
{
    
    // The folowing lines should not surpriseful
    
    SoftPixelDevice* spDevice = createDevice(
        ChooseRenderer(), dim::size2di(1280, 1024), 32, "Tutorial16 (GUI)", !false
    );
    
    video::VideoDriver* spDriver = spDevice->getVideoDriver();
    UserControl* spControl = spDevice->getUserControl();
    
    spControl->hideCursor(false);
    
    video::gui::GUI* myGUI = spDriver->getGUI();
    
    video::gui::GUIWindow* hWnd1 = myGUI->createWindow("GUI Tutorial", dim::point2di(0, 50), dim::size2di(300, 200),
        video::gui::WINDOW_BUTTON_X | video::gui::WINDOW_BUTTON_MIN | video::gui::WINDOW_BUTTON_MAX | video::gui::WINDOW_BUTTON_SIZE |
        video::gui::WINDOW_STATUSBAR | video::gui::WINDOW_CENTERED);
    video::gui::GUIWindow* hWnd2 = myGUI->createWindow("SoftPixel Engine", dim::point2di(300, 250), dim::size2di(300, 300));
    
    video::gui::GUIButton* hBtn1 = hWnd1->createButton("This is a very big button!", dim::point2di(50, 50), hWnd1->getSize()-dim::size2di(100, 100), video::gui::BUTTON_NORMAL);
    video::gui::GUIButton* hBtn2 = hWnd2->createButton("OK", dim::point2di(25, 25), dim::size2di(80, 25), video::gui::BUTTON_NORMAL);
    
    spDriver->setClearColor(video::color(255));
    
    s32 GUIEvent;
    
    while (spDevice->updateEvent() && !spControl->isKeyPressed(KEY_ESCAPE))
    {
        spDriver->clearBuffers();
        
        GUIEvent = myGUI->updateGUIEvent();
        myGUI->renderGUI();
        
        switch (GUIEvent)
        {
            case video::gui::WINDOW_CLOSE:
                myGUI->deleteWindow(myGUI->getFocusedWindow());
                break;
            case video::gui::BUTTON_CLICKED:
                if (myGUI->getFocusedObject() == hBtn1)
                    spDevice->beep(); // Test signal
                break;
        }
        
        spDriver->flipBuffers();
    }
    
    deleteDevice();
    
    return 0;
}


// Sprite functions




// ======================================================
