// Fragment/ Pixel Shader Demo - HLSL
// Copyright (c) 2009 Lukas Hermanns

float4x4 WorldViewProj;
int Demo;


// Vertex shader output
struct VS_OUTPUT
{
	float4 Position	: POSITION;		// Vertex position
	float2 TexCoord	: TEXCOORD0;	// Texture coordinate
};


VS_OUTPUT MainVertex(
	in float4 Position	: POSITION,
	float2 TexCoord		: TEXCOORD0)
{
	VS_OUTPUT Output;
	
	Output.Position = mul(Position, WorldViewProj);
	Output.TexCoord = TexCoord;
	
	return Output;
}


// Pixel shader output
struct PS_OUTPUT
{
    float4 Color	: COLOR0;	// Pixel color
};


sampler2D tex0;

PS_OUTPUT MainPixel(
	float2 TexCoord	: TEXCOORD0,
	float4 Position	: POSITION,
	float4 Diffuse	: COLOR0) 
{ 
	PS_OUTPUT Output;
	
	float4 RGB = tex2D(tex0, TexCoord);
	
	/*
	if (Position.y < 0.0)
	{
		if (Position.x < 0.0)
		{
			if ( (RGB.r + RGB.g + RGB.b)/3.0 >= 0.5)
				Output.Color = float4(1.0, 1.0, 1.0, RGB.a);
			else
				Output.Color = float4(0.0, 0.0, 0.0, RGB.a);
		}
		else
		{
			Output.Color = float4(
				( RGB.r + RGB.g + RGB.b ) / 3.0,
				( RGB.r + RGB.g + RGB.b ) / 3.0,
				( RGB.r + RGB.g + RGB.b ) / 3.0,
				RGB.a
			);
		}
	}
	else
	{
		if (Position.x > 0.0)
			Output.Color = float4(1.0 - RGB.r, 1.0 - RGB.g, 1.0 - RGB.b, RGB.a);
		else
			Output.Color = RGB;
	}
	*/
	
	return Output;
}
