// Fragment/ Pixel Shader Demo - GLSL
// Copyright (c) 2008 Lukas Hermanns

uniform sampler2D Texture0;
varying vec4 vertPosition;

void main(void)
{
	vec2 TexCoord = vec2(gl_TexCoord[0]);
	vec4 RGB      = texture2D(Texture0, TexCoord);
	
	if (vertPosition.y < 0.0)
	{
		if (vertPosition.x < 0.0)
		{
			if ( (RGB.r + RGB.g + RGB.b)/3.0 >= 0.5)
				gl_FragColor = vec4(1.0, 1.0, 1.0, RGB.a);
			else
				gl_FragColor = vec4(0.0, 0.0, 0.0, RGB.a);
		}
		else
		{
			gl_FragColor = vec4(
				( RGB.r + RGB.g + RGB.b ) / 3.0,
				( RGB.r + RGB.g + RGB.b ) / 3.0,
				( RGB.r + RGB.g + RGB.b ) / 3.0,
				RGB.a
			);
		}
	}
	else
	{
		if (vertPosition.x > 0.0)
			gl_FragColor = vec4(1.0 - RGB.r, 1.0 - RGB.g, 1.0 - RGB.b, RGB.a);
		else
			gl_FragColor = RGB;
	}
}
