//
// SoftPixel Engine - Tutorial7 (SoundMusic) - (24.1.2008)
//

#include <SoftPixelEngine.hpp>

using namespace sp; // Main namespace


int main()
{
    
    // The console will be opened allways but we want to set the console title
    // (If you don`n want a console you can close it with the 'io::closeConsole()' function)
    io::openConsole("Tutorial7 (Sound & Music)");
    
    // Creates the 'SensitiveSound System' (you can enter parameters for 3d sounds)
    sound::SensitiveSoundDevice* listener = sound::createListener();
    
    sound::Sound* snd;
    
    // Loads a local sound
    snd = listener->loadSound("../../../media/DemoMusic1.mid");
    
    // Check something out!
    listener->setSoundVolume(snd, 0.25f);
    //listener->setSoundSpeed(snd, 0.25f);
    //listener->setSoundPan(snd, -1.0f, 0.25f);
    listener->playSound(snd);
    
    io::printMessage("\nMusic state:");
    
    while (!listener->isSoundFinished(snd))
    {
        Sleep(1000);
        io::printMessage(listener->getSoundSeek(snd));
    }
    
    listener->deleteDevice();
    
    return 0;
}




// ======================================================
