//
// SoftPixel Engine - Tutorial8(ModelLoading) - (6.2.2008)
//

#include <SoftPixelEngine.hpp>

using namespace sp; // Main namespace

#include "../common.hpp"

int main()
{
    
    // The folowing lines should not surpriseful
    
    SoftPixelDevice* spDevice = createDevice(
        ChooseRenderer(), dim::size2di(800, 600), 32, "Tutorial8 (ModelLoading)"
    );
    
    video::VideoDriver* spDriver = spDevice->getVideoDriver();
    scene::SceneManager* spSmngr = spDevice->getSceneManager();
    UserControl* spControl = spDevice->getUserControl();
    
    spDevice->setWindowTitle(
        spDevice->getWindowTitle() + io::stringc(" [ ") + spDriver->getVersion() + io::stringc(" ]")
    );
    
    scene::Camera* cam = spSmngr->createCamera();
    
    scene::Entity* mesh = spSmngr->loadModel("model/character.ms3d");
    
    mesh->setScale(0.05f);
    mesh->setPosition(dim::vector3df(0, 0, 3.5));
    
    spDriver->setClearColor(video::color(0, 0, 64));
    
    dim::point2di CursorSpeed;
    
    while (spDevice->updateEvent() && !spControl->isKeyPressed(KEY_ESCAPE))
    {
        spDriver->clearBuffers();
        
        spSmngr->renderScene();
        
        CursorSpeed = spControl->getCursorSpeed();
        
        mesh->doTurn(dim::vector3df(-CursorSpeed.Y, -CursorSpeed.X, 0));
        
        spDriver->flipBuffers();
    }
    
    deleteDevice();
    
    return 0;
}

// ======================================================
