/*
 * **********************************
 *                                   *
 * HLC Games, Spiele und Software     *
 *                                     *
 * (c) Copyright 2003 - Lukas Hermanns  *
 *                                       *
 * ****************************************
 *  ___    ___    ___          _____
 * /\  \  /\  \  /\  \        /  ___\
 * \ \  \_\_\  \ \ \  \      /\  \__/
 *  \ \   ___   \ \ \  \     \ \  \
 *   \ \  \__/\  \ \ \  \____ \ \  \___
 *    \ \__\ \ \__\ \ \______\ \ \_____\
 *     \/__/  \/__/  \/______/  \/_____/
 *
 * ****************************************
 *
 * ********************** HLC SoftPixelEngine - (3.1.2008) ************************
 *
 * (c) Copyright 2008 - Lukas Hermanns
 *
 * File header
 *
 */

#ifndef __SP_INPUTOUTPUT_FILE_H__
#define __SP_INPUTOUTPUT_FILE_H__


#include "spStandard.hpp"
#include "spInputOutputString.hpp"

#include <cstdlib>
#include <sstream>
#include <string>
#include <cstdio>


namespace sp
{
namespace io
{


class SP_EXPORT File
{
    
    public:
        
        File();
        File(FILE* hID, u32 Length);
        ~File();
        
        inline stringc getFilename()
        {
            return Filename_;
        }
        inline u32 getLength()
        {
            return Length_;
        }
        inline FILE* getID()
        {
            return hID_;
        }
        
    private:
        
        stringc Filename_;
        u32 Length_;
        FILE* hID_;
        
};


} // /namespace io

} // /namespace sp


#endif









// ================================================================================
