/*
 * **********************************
 *                                   *
 * HLC Games, Spiele und Software     *
 *                                     *
 * (c) Copyright 2003 - Lukas Hermanns  *
 *                                       *
 * ****************************************
 *  ___    ___    ___          _____
 * /\  \  /\  \  /\  \        /  ___\
 * \ \  \_\_\  \ \ \  \      /\  \__/
 *  \ \   ___   \ \ \  \     \ \  \
 *   \ \  \__/\  \ \ \  \____ \ \  \___
 *    \ \__\ \ \__\ \ \______\ \ \_____\
 *     \/__/  \/__/  \/______/  \/_____/
 *
 * ****************************************
 *
 * ********************** HLC SoftPixelEngine - (3.1.2008) ************************
 *
 * (c) Copyright 2008 - Lukas Hermanns
 *
 * OperatingSystem informator header
 *
 */

#ifndef __SP_INPUTOUTPUT_OSINFORMATOR_H__
#define __SP_INPUTOUTPUT_OSINFORMATOR_H__


#include "spStandard.hpp"
#include "spInputOutputString.hpp"


namespace sp
{
namespace io
{


enum EByteTypes
{
    SIZE_BYTE = 0,
    SIZE_KB,
    SIZE_MB,
    SIZE_GB
};


class SP_EXPORT OSInformator
{
    
    public:
        
        OSInformator();
        ~OSInformator();
        
        inline stringc getOSVersion()
        {
            return OSVersion_;
        }
        
        void setClipboardText(stringc Text);
        stringc getClipboardText();
        
        u32 getProcessorSpeed(); // (in MHz)
        
        void getDiskSpace(stringc PartitionName, u32 &Total, u32 &Free);
        void getVirtualMemory(f32 &Total, f32 &Free, s32 SizeType = SIZE_MB);
        
    private:
        
        stringc allocOSVersion();
        
        stringc OSVersion_;
        
};


} // /namespace io

} // /namespace sp


#endif








// ================================================================================
