/*
 * **********************************
 *                                   *
 * HLC Games, Spiele und Software     *
 *                                     *
 * (c) Copyright 2003 - Lukas Hermanns  *
 *                                       *
 * ****************************************
 *  ___    ___    ___          _____
 * /\  \  /\  \  /\  \        /  ___\
 * \ \  \_\_\  \ \ \  \      /\  \__/
 *  \ \   ___   \ \ \  \     \ \  \
 *   \ \  \__/\  \ \ \  \____ \ \  \___
 *    \ \__\ \ \__\ \ \______\ \ \_____\
 *     \/__/  \/__/  \/______/  \/_____/
 *
 * ****************************************
 *
 * ********************** HLC SoftPixelEngine - (3.1.2008) ************************
 *
 * (c) Copyright 2008 - Lukas Hermanns
 *
 * Standard InputOutput
 *
 */

#ifndef __SP_INPUTOUTPUT_STD_H__
#define __SP_INPUTOUTPUT_STD_H__


#include "spStandard.hpp"
#include "spInputOutputString.hpp"
#include "spDimension.hpp"

#include <fstream>


namespace sp
{
namespace io
{


#define __SP_STD_DEBUGLOG_FILENAME  "spDebugLog.txt"

enum EInfoColorTypes
{
    INFO_WARNING,
    INFO_ERROR
};


/* Standard input output functions */

SP_EXPORT void openConsole(stringc Title = "");
SP_EXPORT void closeConsole();
SP_EXPORT void clearConsole();
SP_EXPORT void pauseConsole();

SP_EXPORT void printInfo(stringc Message, EInfoColorTypes Color);

SP_EXPORT void printMessage(stringc Message);
SP_EXPORT void printWarning(stringc Message);
SP_EXPORT void printError(stringc Message);

SP_EXPORT void getMessage(stringc Message);
SP_EXPORT void getWarning(stringc Message);
SP_EXPORT void getError(stringc Message);

SP_EXPORT void setDebugLog(bool isDebugLog, io::stringc Filename = __SP_STD_DEBUGLOG_FILENAME);

SP_EXPORT void logOpen(stringc Filename);
SP_EXPORT void logMessage(stringc Message);
SP_EXPORT void logClose();

SP_EXPORT stringc getDebugString(dim::vector3df Value);
SP_EXPORT stringc getDebugString(dim::quaternion Value);
SP_EXPORT stringc getDebugString(dim::matrix4f Value);


} // /namespace io

} // /namespace sp


#endif








// ================================================================================
