/*
 * **********************************
 *                                   *
 * HLC Games, Spiele und Software     *
 *                                     *
 * (c) Copyright 2003 - Lukas Hermanns  *
 *                                       *
 * ****************************************
 *  ___    ___    ___          _____
 * /\  \  /\  \  /\  \        /  ___\
 * \ \  \_\_\  \ \ \  \      /\  \__/
 *  \ \   ___   \ \ \  \     \ \  \
 *   \ \  \__/\  \ \ \  \____ \ \  \___
 *    \ \__\ \ \__\ \ \______\ \ \_____\
 *     \/__/  \/__/  \/______/  \/_____/
 *
 * ****************************************
 *
 * ********************** HLC SoftPixelEngine - (3.1.2008) ************************
 *
 * (c) Copyright 2008 - Lukas Hermanns
 *
 * Header for all model loading fileformats
 *
 */

#ifndef __SP_MODEL_MANAGER_H__
#define __SP_MODEL_MANAGER_H__


#include "spStandard.hpp"

/* ModelLoader: */

#include "spModelLoaderRAW.hpp"

#include "spModelLoaderSPM.hpp"     // SoftPixel Model
#include "spModelLoader3DS.hpp"     // 3D Studio
#include "spModelLoaderMS3D.hpp"    // Milkshape 3D
#include "spModelLoaderD3D.hpp"     // DirectX
#include "spModelLoaderB3D.hpp"     // Blitz3D
#include "spModelLoaderMD2.hpp"     // Quake II
#include "spModelLoaderOBJ.hpp"     // Wavefront Object
#include "spModelLoaderTMF.hpp"     // ToxyVision

/* ModelSaver: */

#include "spModelSaverRAW.hpp"

#include "spModelSaverSPM.hpp"
#include "spModelSaverB3D.hpp"
#include "spModelSaverOBJ.hpp"

/* SceneLoader: */

#include "spSceneLoaderSPS.hpp"     // SoftPixel Scene
#include "spSceneLoaderBSP3.hpp"    // Quake III Arena level
#include "spSceneLoaderBSP1.hpp"    // Quake 1/ Half-Life 1/ Counter-Strike 1.0 - 1.6 level



#endif





// ================================================================================
