/*
 * **********************************
 *                                   *
 * HLC Games, Spiele und Software     *
 *                                     *
 * (c) Copyright 2003 - Lukas Hermanns  *
 *                                       *
 * ****************************************
 *  ___    ___    ___          _____
 * /\  \  /\  \  /\  \        /  ___\
 * \ \  \_\_\  \ \ \  \      /\  \__/
 *  \ \   ___   \ \ \  \     \ \  \
 *   \ \  \__/\  \ \ \  \____ \ \  \___
 *    \ \__\ \ \__\ \ \______\ \ \_____\
 *     \/__/  \/__/  \/______/  \/_____/
 *
 * ****************************************
 *
 * ********************** HLC SoftPixelEngine - (3.1.2008) ************************
 *
 * (c) Copyright 2008 - Lukas Hermanns
 *
 * Header for model saving B3D-fileformat (Blitz3D)
 *
 */

#ifndef __SP_MODELSAVER_B3D_H__
#define __SP_MODELSAVER_B3D_H__


#include "spStandard.hpp"
#include "spModelSaverRAW.hpp"


namespace sp
{
namespace scene
{


class SP_EXPORT ModelSaverB3D : public ModelSaverRAW
{
    
    public:
        
        ModelSaverB3D();
        ~ModelSaverB3D();
        
        bool saveModel(Entity* hEntity, io::stringc &Filename);
        
    private:
        
        /* === Functions === */
        
        void init();
        void clear();
        
        void beginChunk(io::stringc Tag);
        void endChunk();
        
        void saveModelData();
        void writeMesh();
        
        /* === Members === */
        
        std::vector<video::Texture*> TextureList_;
        
        s32 Stack_[100];
        s32 CurPos_;
        
};


} // /namespace scene

} // /namespace sp


#endif





// ================================================================================
