/*
 * **********************************
 *                                   *
 * HLC Games, Spiele und Software     *
 *                                     *
 * (c) Copyright 2003 - Lukas Hermanns  *
 *                                       *
 * ****************************************
 *  ___    ___    ___          _____
 * /\  \  /\  \  /\  \        /  ___\
 * \ \  \_\_\  \ \ \  \      /\  \__/
 *  \ \   ___   \ \ \  \     \ \  \
 *   \ \  \__/\  \ \ \  \____ \ \  \___
 *    \ \__\ \ \__\ \ \______\ \ \_____\
 *     \/__/  \/__/  \/______/  \/_____/
 *
 * ****************************************
 *
 * ********************** HLC SoftPixelEngine - (3.1.2008) ************************
 *
 * (c) Copyright 2008 - Lukas Hermanns
 *
 * Header for model saving RAW
 *
 */

#ifndef __SP_MODELSAVER_RAW_H__
#define __SP_MODELSAVER_RAW_H__


#include "spStandard.hpp"
#include "spInputOutput.hpp"
#include "spSceneManagerEntity.hpp"
#include "spSceneManagerAnimator.hpp"
#include "spVideoDriverTexture.hpp"
#include "spDimension.hpp"


namespace sp
{
namespace scene
{


extern anim::Animator* __spAnimator;


/*
 * ======= ModelSaverRAW class =======
 */

class SP_EXPORT ModelSaverRAW
{
    
    public:
        
        virtual ~ModelSaverRAW()
        {
        }
        
        virtual bool saveModel(Entity* hEntity, io::stringc &Filename) = 0;
        
    protected:
        
        /* Protected functions */
        
        ModelSaverRAW() : hEntity_(0), Anim_(0), FileLoader_(0), hFile_(0)
        {
        }
        
        inline bool openSaveFile(Entity* hEntity, const io::stringc &Filename)
        {
            Filename_   = Filename;
            hEntity_    = hEntity;
            
            return ( hFile_ = FileLoader_->openFile(Filename, io::FILE_WRITE_BINARY) ) != 0;
        }
        
        /* Members */
        
        Entity* hEntity_;
        
        anim::Animation* Anim_;
        
        io::FileLoader* FileLoader_;
        io::File* hFile_;
        
        io::stringc Filename_;
        
};


} // /namespace scene

} // /namespace sp


#endif





// ================================================================================
