/*
 * **********************************
 *                                   *
 * HLC Games, Spiele und Software     *
 *                                     *
 * (c) Copyright 2003 - Lukas Hermanns  *
 *                                       *
 * ****************************************
 *  ___    ___    ___          _____
 * /\  \  /\  \  /\  \        /  ___\
 * \ \  \_\_\  \ \ \  \      /\  \__/
 *  \ \   ___   \ \ \  \     \ \  \
 *   \ \  \__/\  \ \ \  \____ \ \  \___
 *    \ \__\ \ \__\ \ \______\ \ \_____\
 *     \/__/  \/__/  \/______/  \/_____/
 *
 * ****************************************
 *
 * ********************** HLC SoftPixelEngine - (3.1.2008) ************************
 *
 * (c) Copyright 2008 - Lukas Hermanns
 *
 * Header for model saving SPM-fileformat
 *
 */

#ifndef __SP_MODELSAVER_SPM_H__
#define __SP_MODELSAVER_SPM_H__


#include "spStandard.hpp"
#include "spModelLoaderSPM.hpp"
#include "spModelSaverRAW.hpp"


namespace sp
{
namespace scene
{


class SP_EXPORT ModelSaverSPM : public ModelSaverRAW
{
    
    public:
        
        ModelSaverSPM();
        ~ModelSaverSPM();
        
        bool saveModel(Entity* hEntity, io::stringc &Filename);
        
    private:
        
        /* Functions */
        
        void writeChunk(u16 ID, u32 Length);
        
        void writeAllChunks();
        
};


} // /namespace scene

} // /namespace sp


#endif





// ================================================================================
