/*
 * **********************************
 *                                   *
 * HLC Games, Spiele und Software     *
 *                                     *
 * (c) Copyright 2003 - Lukas Hermanns  *
 *                                       *
 * ****************************************
 *  ___    ___    ___          _____
 * /\  \  /\  \  /\  \        /  ___\
 * \ \  \_\_\  \ \ \  \      /\  \__/
 *  \ \   ___   \ \ \  \     \ \  \
 *   \ \  \__/\  \ \ \  \____ \ \  \___
 *    \ \__\ \ \__\ \ \______\ \ \_____\
 *     \/__/  \/__/  \/______/  \/_____/
 *
 * ****************************************
 *
 * ********************** HLC SoftPixelEngine - (3.1.2008) ************************
 *
 * (c) Copyright 2008 - Lukas Hermanns
 *
 * Header for the movie-sequence-packet
 *
 */

#ifndef __SP_MOVIESEQUENCEPACKET_H__
#define __SP_MOVIESEQUENCEPACKET_H__


#include "spStandard.hpp"
#include "spDimensionSize2D.hpp"
#include "spInputOutputString.hpp"

#if defined(WIN32)
#   include <vfw.h>
#endif


namespace sp
{
namespace video
{
namespace movie
{


#if defined(WIN32)

struct SMovieSequencePacket
{
    
    // General
    dim::size2di Size;
    s32 mpf;
    long lastframe;
    s8* pdata;
    u8* data;
    
    // Movie state
    s32 next, frame;
    s8 state;
    u32 time, last_time;
    s32 Resolution;
    bool isLoop;
    
    // Buffers and data
    AVISTREAMINFO psi;
    PAVISTREAM pavi, paudio;
    PGETFRAME pgf;
    BITMAPINFOHEADER bmih;
    HDRAWDIB hdd;
    HBITMAP hBitmap;
    HDC hDC;
    
};

#endif


} // /namespace movie

} // /namespace video

} // /namespace sp


#endif






// ================================================================================
