/*
 * **********************************
 *                                   *
 * HLC Games, Spiele und Software     *
 *                                     *
 * (c) Copyright 2003 - Lukas Hermanns  *
 *                                       *
 * ****************************************
 *  ___    ___    ___          _____
 * /\  \  /\  \  /\  \        /  ___\
 * \ \  \_\_\  \ \ \  \      /\  \__/
 *  \ \   ___   \ \ \  \     \ \  \
 *   \ \  \__/\  \ \ \  \____ \ \  \___
 *    \ \__\ \ \__\ \ \______\ \ \_____\
 *     \/__/  \/__/  \/______/  \/_____/
 *
 * ****************************************
 *
 * ********************** HLC SoftPixelEngine - (3.1.2008) ************************
 *
 * (c) Copyright 2008 - Lukas Hermanns
 *
 * Header for all OpenGL ARB function declerations
 *
 */

#ifndef __SP_OPENGLFUNCTIONSARB_H__
#define __SP_OPENGLFUNCTIONSARB_H__


#if defined(WIN32)
#   include <windows.h>
#elif defined(LINUX)
#   include <sys/utsname.h>
#endif

#include <gl/gl.h>
#include <gl/glext.h>

#if defined(WIN32)
#   include <gl/wglext.h>
#endif


namespace sp
{


// Somethins else

typedef BOOL (APIENTRY * PFNWGLSWAPINTERVALFARPROC)(int);

// VBO type definations
typedef void (APIENTRY * PFNGLBINDBUFFERARBPROC)    (GLenum target, GLuint buffer);
typedef void (APIENTRY * PFNGLDELETEBUFFERSARBPROC) (GLsizei n, const GLuint* buffers);
typedef void (APIENTRY * PFNGLGENBUFFERSARBPROC)    (GLsizei n, GLuint* buffers);
typedef void (APIENTRY * PFNGLBUFFERDATAARBPROC)    (GLenum target, int size, const GLvoid* data, GLenum usage);

/* Function pointer (OpenGL extensions & ARB functions) */

// OpenGL extendet functions -> (glext.h)
// Multitexturing: GL_TEXTURE0_ARB - GL_TEXTURE31_ARB

extern PFNGLMULTITEXCOORD2FARBPROC          glMultiTexCoord2fARB;
extern PFNGLACTIVETEXTUREARBPROC            glActiveTextureARB;
extern PFNWGLCHOOSEPIXELFORMATARBPROC       wglChoosePixelFormatARB;
extern PFNWGLSWAPINTERVALFARPROC            wglSwapIntervalEXT;
//extern PFNGLACTIVESTENCILFACEEXTPROC        glActiveStencilFaceEXT;
extern PFNGLTEXIMAGE3DEXTPROC               glTexImage3DEXT;

/* VBO extension function pointers */

extern PFNGLCLIENTACTIVETEXTUREARBPROC      glClientActiveTextureARB;
extern PFNGLFOGCOORDPOINTERPROC             glFogCoordPointer;

extern PFNGLGENBUFFERSARBPROC               glGenBuffersARB;
extern PFNGLBINDBUFFERARBPROC               glBindBufferARB;
extern PFNGLBUFFERDATAARBPROC               glBufferDataARB;
extern PFNGLDELETEBUFFERSARBPROC            glDeleteBuffersARB;

/* Shader (GLSL) */

extern PFNGLBINDPROGRAMARBPROC              glBindProgramARB;
extern PFNGLPROGRAMSTRINGARBPROC            glProgramStringARB;
extern PFNGLGENPROGRAMSARBPROC              glGenProgramsARB;
extern PFNGLDELETEPROGRAMSARBPROC           glDeleteProgramsARB;
extern PFNGLPROGRAMLOCALPARAMETER4FVARBPROC glProgramLocalParameter4fvARB;

extern PFNGLDELETEPROGRAMPROC               glDeleteProgram;
extern PFNGLDELETESHADERPROC                glDeleteShader;
extern PFNGLCREATEPROGRAMOBJECTARBPROC      glCreateProgramObjectARB;
extern PFNGLCREATESHADEROBJECTARBPROC       glCreateShaderObjectARB;
extern PFNGLSHADERSOURCEARBPROC             glShaderSourceARB;
extern PFNGLCOMPILESHADERARBPROC            glCompileShaderARB;
extern PFNGLATTACHOBJECTARBPROC             glAttachObjectARB;
extern PFNGLDELETEOBJECTARBPROC             glDeleteObjectARB;
extern PFNGLLINKPROGRAMARBPROC              glLinkProgramARB;
extern PFNGLUSEPROGRAMOBJECTARBPROC         glUseProgramObjectARB;
extern PFNGLGETOBJECTPARAMETERIVARBPROC     glGetObjectParameterivARB;
extern PFNGLGETINFOLOGARBPROC               glGetInfoLogARB;
extern PFNGLDETACHOBJECTARBPROC             glDetachObjectARB;
extern PFNGLGETACTIVEUNIFORMARBPROC         glGetActiveUniformARB;
extern PFNGLUNIFORM1FARBPROC                glUniform1fARB;
extern PFNGLUNIFORM3FARBPROC                glUniform3fARB;
extern PFNGLUNIFORM4FARBPROC                glUniform4fARB;
extern PFNGLUNIFORM1IARBPROC                glUniform1iARB;
extern PFNGLUNIFORM1IVARBPROC               glUniform1ivARB;
extern PFNGLUNIFORM1FVARBPROC               glUniform1fvARB;
extern PFNGLUNIFORM2FVARBPROC               glUniform2fvARB;
extern PFNGLUNIFORM3FVARBPROC               glUniform3fvARB;
extern PFNGLUNIFORM4FVARBPROC               glUniform4fvARB;
extern PFNGLUNIFORMMATRIX2FVARBPROC         glUniformMatrix2fvARB;
extern PFNGLUNIFORMMATRIX3FVARBPROC         glUniformMatrix3fvARB;
extern PFNGLUNIFORMMATRIX4FVARBPROC         glUniformMatrix4fvARB;


} // /namespace sp


#endif









// ================================================================================
