/*
 * **********************************
 *                                   *
 * HLC Games, Spiele und Software     *
 *                                     *
 * (c) Copyright 2003 - Lukas Hermanns  *
 *                                       *
 * ****************************************
 *  ___    ___    ___          _____
 * /\  \  /\  \  /\  \        /  ___\
 * \ \  \_\_\  \ \ \  \      /\  \__/
 *  \ \   ___   \ \ \  \     \ \  \
 *   \ \  \__/\  \ \ \  \____ \ \  \___
 *    \ \__\ \ \__\ \ \______\ \ \_____\
 *     \/__/  \/__/  \/______/  \/_____/
 *
 * ****************************************
 *
 * ********************** HLC SoftPixelEngine - (3.1.2008) ************************
 *
 * (c) Copyright 2008 - Lukas Hermanns
 *
 * Header for OpenGL special effects actor (BumpMapping, FurEffect, CelShading, BlurEffect)
 *
 */

#ifndef __SP_OPENGL_SPECIALEFFECTSACTOR_H__
#define __SP_OPENGL_SPECIALEFFECTSACTOR_H__


#include "spStandard.hpp"
#include "spSceneManagerSpecialEffectsActor.hpp"


namespace sp
{
namespace scene
{
namespace effect
{


class SP_EXPORT OpenGLSpecialEffectsActor : public SpecialEffectsActor
{
    
    public:
        
        OpenGLSpecialEffectsActor();
        ~OpenGLSpecialEffectsActor();
        
        /* === Bump mapping === */
        
        
        /* === Cel shading === */
        
        CelShadow* createCelShadow(
            s32 LevelsCount = 8, video::color ShadowColor = video::color(255),
            video::color DarknessColor = video::color(0)
        );
        CelShadow* createCelShadow(s32 LevelsCount, video::color* LevelsColor);
        
        void deleteCelShadow(CelShadow* &hCelShadow);
        
        /* === Render functions === */
        
        /*void renderBumpMapping(
            Entity* hEntity, video::Texture* BumpTexture, f32 BumpHeight, Light* hLight
        );*/
        
        void renderCelShading(
            Entity* hEntity, CelShadow* hCelShadow, Light* hLight
        );
        
        void renderBlurEffect(
            Entity* hEntity, s32 LevelsCount = __SP_BE_STDLEVELSCOUNT,
            f32 LevelsDist = __SP_BE_STDLEVELSDIST, u8 ColorAlpha = 255
        );
        
    private:
        
        /* === Bump mapping === */
        
        
        /* === Cel shading === */
        
        void renderCelShaderSolid(Entity* hEntity, Light* hLight);
        void renderCelShaderWire(Entity* hEntity);
        
};


} // /namespace effect

} // /namespace scene

} // /namespace sp


#endif







// ================================================================================
