/*
 * **********************************
 *                                   *
 * HLC Games, Spiele und Software     *
 *                                     *
 * (c) Copyright 2003 - Lukas Hermanns  *
 *                                       *
 * ****************************************
 *  ___    ___    ___          _____
 * /\  \  /\  \  /\  \        /  ___\
 * \ \  \_\_\  \ \ \  \      /\  \__/
 *  \ \   ___   \ \ \  \     \ \  \
 *   \ \  \__/\  \ \ \  \____ \ \  \___
 *    \ \__\ \ \__\ \ \______\ \ \_____\
 *     \/__/  \/__/  \/______/  \/_____/
 *
 * ****************************************
 *
 * ********************** HLC SoftPixelEngine - (3.1.2008) ************************
 *
 * (c) Copyright 2008 - Lukas Hermanns
 *
 * Header for scene loading SPS-scene file format
 *
 */

#ifndef __SP_SCENELOADER_SPS_H__
#define __SP_SCENELOADER_SPS_H__


#include "spStandard.hpp"
#include "spInputOutputStandard.hpp"
#include "spInputOutputFileSystem.hpp"
#include "spDimension.hpp"
#include "spSceneManagerEntity.hpp"
#include "spVideoDriverTexture.hpp"
#include "spModelLoaderRAW.hpp"

#include <list>


namespace sp
{
namespace scene
{


#define SCENEOBJ_PRIMITIVE  0x01
#define SCENEOBJ_MODEL      0x02


class SP_EXPORT SceneLoaderSPS : public SceneLoaderRAW
{
    
    public:
        
        SceneLoaderSPS();
        ~SceneLoaderSPS();
        
        Entity* loadScene(SceneManager* SceneMngr, io::stringc &Filename, io::stringc &TexturePath, s32 Tesselation);
        
    private:
        
        /* Functions */
        
        void loadSceneData();
        void readSceneObjPrimitive();
        void readSceneObjModel();
        void readSceneObjLocation();
        
        /* Members */
        
        Entity* CurEntity_;
        
};


} // /namespace scene

} // /namespace sp


#endif





// ================================================================================
