/*
 * **********************************
 *                                   *
 * HLC Games, Spiele und Software     *
 *                                     *
 * (c) Copyright 2003 - Lukas Hermanns  *
 *                                       *
 * ****************************************
 *  ___    ___    ___          _____
 * /\  \  /\  \  /\  \        /  ___\
 * \ \  \_\_\  \ \ \  \      /\  \__/
 *  \ \   ___   \ \ \  \     \ \  \
 *   \ \  \__/\  \ \ \  \____ \ \  \___
 *    \ \__\ \ \__\ \ \______\ \ \_____\
 *     \/__/  \/__/  \/______/  \/_____/
 *
 * ****************************************
 *
 * ********************** HLC SoftPixelEngine - (3.1.2008) ************************
 *
 * (c) Copyright 2008 - Lukas Hermanns
 *
 * Header for terrains
 *
 */

#ifndef __SP_SCENEMANAGER_TERRAIN_H__
#define __SP_SCENEMANAGER_TERRAIN_H__


#include "spStandard.hpp"
#include "spSceneManagerEntity.hpp"
#include "spVideoDriverTexture.hpp"


namespace sp
{
namespace scene
{


#define __SP_TERRAIN_MAXDETAIL_X        5
#define __SP_TERRAIN_MAXDETAIL_Z        5
#define __SP_TERRAIN_MAXDETAIL_PATCHES  4
#define __SP_TERRAIN_STD_CHANGEDIST     25

// Look for: "GeoMipMapping"

class SP_EXPORT Terrain : public Node
{
    
    public:
        
        Terrain();
        Terrain(video::Texture* hTextureHighMap, video::Texture* hTexture, f32 ChangeDist);
        ~Terrain();
        
        void render(dim::vector3df CamPosition);
        
        Entity* getEntityList(u32 X, u32 Z, u32 Patch)
        {
            return hEntityPatches_[X][Z][Patch];
        }
        
        void setWireframe(s32 Type);
        
        /* Matrix transformation */
        
        void updateModelviewMatrix();
        
    private:
        
        void createHighMap();
        
        video::Texture* hTextureHighMap_;
        video::Texture* hTexture_;
        Entity* hEntityPatches_[__SP_TERRAIN_MAXDETAIL_X][__SP_TERRAIN_MAXDETAIL_Z][__SP_TERRAIN_MAXDETAIL_PATCHES];
        f32 ChangeDist_;
        
};


} // /namespace scene

} // /namespace sp


#endif







// ================================================================================
