/*
 * **********************************
 *                                   *
 * HLC Games, Spiele und Software     *
 *                                     *
 * (c) Copyright 2003 - Lukas Hermanns  *
 *                                       *
 * ****************************************
 *  ___    ___    ___          _____
 * /\  \  /\  \  /\  \        /  ___\
 * \ \  \_\_\  \ \ \  \      /\  \__/
 *  \ \   ___   \ \ \  \     \ \  \
 *   \ \  \__/\  \ \ \  \____ \ \  \___
 *    \ \__\ \ \__\ \ \______\ \ \_____\
 *     \/__/  \/__/  \/______/  \/_____/
 *
 * ****************************************
 *
 * ********************** HLC SoftPixelEngine - (3.1.2008) ************************
 *
 * (c) Copyright 2008 - Lukas Hermanns
 *
 * Header for recordings
 *
 */

#ifndef __SP_SENSITIVESOUND_RECORD_H__
#define __SP_SENSITIVESOUND_RECORD_H__


#include "spStandard.hpp"
#include "spInputOutputString.hpp"


namespace sp
{
namespace sound
{


static const s32 DEF_RECORD_BUFFERSIZE  = 128;


class SP_EXPORT Record
{
        
    public:
            
        Record();
        ~Record();
        
        /* Functions */
        
        void beginRecording();
        void endRecording();
        
        void saveRecord(io::stringc Filename);
        
        /* Inline functions */
        
        inline bool isRecording() const
        {
            return isRecording_;
        }
        inline u32 getID() const
        {
            return ID_;
        }
        
    private:
        
        /* Members */
            
        u32 ID_;
        bool isRecording_;
        
        c8 RecBuffer_[DEF_RECORD_BUFFERSIZE];
        
};


} // /namespace sound

} // /namespace sp


#endif






// ================================================================================
