/*
 * **********************************
 *                                   *
 * HLC Games, Spiele und Software     *
 *                                     *
 * (c) Copyright 2003 - Lukas Hermanns  *
 *                                       *
 * ****************************************
 *  ___    ___    ___          _____
 * /\  \  /\  \  /\  \        /  ___\
 * \ \  \_\_\  \ \ \  \      /\  \__/
 *  \ \   ___   \ \ \  \     \ \  \
 *   \ \  \__/\  \ \ \  \____ \ \  \___
 *    \ \__\ \ \__\ \ \______\ \ \_____\
 *     \/__/  \/__/  \/______/  \/_____/
 *
 * ****************************************
 *
 * ********************** HLC SoftPixelEngine - (3.1.2008) ************************
 *
 * (c) Copyright 2008 - Lukas Hermanns
 *
 * Header for all standards (typedes)
 *
 */

#ifndef __SP_STANDARD_H__
#define __SP_STANDARD_H__


#define __SOFTPIXELENGINE__                     // SoftPixel Engine identity
#define __SP_SOFTPIXELENGINE_VERSION__ 0x1700   // Version A.B.C.D (e.g. 1.3.0.9)

#define __SP_EXPORT_TO_LIBRARY__                // Exports the SoftPixel Engine to a library

#ifdef __SP_EXPORT_TO_LIBRARY__
#   if defined(WIN32)
#       define SP_EXPORT __declspec(dllexport)
#   elif defined(LINUX)
#       define SP_EXPORT // ???
#   endif
#else
#   define SP_EXPORT
#endif

#if defined(_MSC_VER)
#   define WIN32
#endif

//#define WIN32SUPPORT (defined(WIN32) || defined(_WIN32))

// !!!
//#include <limits.h>


namespace sp
{


/* Typedefinations */

typedef char                c8;
typedef wchar_t             c16;

typedef signed char         s8;
typedef signed short        s16;
typedef signed int          s32;
typedef signed long int     s64;

typedef unsigned char       u8;
typedef unsigned short      u16;
typedef unsigned int        u32;
typedef unsigned long int   u64;

typedef float               f32;
typedef double              f64;


/* Macros */

#define __SP_SEC                1000.0f

#define __SP_KEYCODE_COUNT      256
#define __SP_MOUSEKEY_COUNT     3

#define __SP_IGNORE             0

#define __SP_FLOAT_ROUND        0.000001f

#define __SP_STD_SCREEN_WIDTH   640
#define __SP_STD_SCREEN_HEIGHT  480

static const f32 DEF_PERSPECTIVE_FOV    = 74.0f;

extern s32 __Screen_Width, __Screen_Height;


} // /namespace sp


#endif









// ================================================================================
