/*
 * **********************************
 *                                   *
 * HLC Games, Spiele und Software     *
 *                                     *
 * (c) Copyright 2003 - Lukas Hermanns  *
 *                                       *
 * ****************************************
 *  ___    ___    ___          _____
 * /\  \  /\  \  /\  \        /  ___\
 * \ \  \_\_\  \ \ \  \      /\  \__/
 *  \ \   ___   \ \ \  \     \ \  \
 *   \ \  \__/\  \ \ \  \____ \ \  \___
 *    \ \__\ \ \__\ \ \______\ \ \_____\
 *     \/__/  \/__/  \/______/  \/_____/
 *
 * ****************************************
 *
 * ********************** HLC SoftPixelEngine - (3.1.2008) ************************
 *
 * (c) Copyright 2008 - Lukas Hermanns
 *
 * Header for texture loading BMP-fileformat
 *
 */

#ifndef __SP_TEXTURELOADER_BMP_H__
#define __SP_TEXTURELOADER_BMP_H__


#include "spStandard.hpp"
#include "spTextureManager.hpp"


namespace sp
{
namespace video
{


#define __SP_BMP_BI_RGB         0
#define __SP_BMP_BI_RLE8        1
#define __SP_BMP_BI_RLE4        2
#define __SP_BMP_BI_BITFIELDS   3

#if defined(_MSC_VER)
#   pragma pack(push, packing)
#   pragma pack(1)
#   define __SP_PACK_STRUCT
#elif defined(__GNUC__)
#   define __SP_PACK_STRUCT __attribute__((packed))
#else
#   define __SP_PACK_STRUCT
#endif

typedef struct SHeaderBMPInfo
{
    u16 ID;
    u32	FileSize, Reserved;
    u32	BitmapDataOffset, BitmapHeaderSize;
    u32 Width, Height;
    u16 Planes, bpp;
    u32 Compression, BitmapDataSize;
    u32 PixelPerMeterX, PixelPerMeterY;
    u32 Colors, ImportantColors;
}
__SP_PACK_STRUCT headerBMPInfo;

#ifdef _MSC_VER
#   pragma pack(pop, packing)
#endif

#undef __SP_PACK_STRUCT


class SP_EXPORT TextureLoaderBMP : public TextureLoaderRAW
{
    
    public:
        
        TextureLoaderBMP(io::stringc &Filename);
        ~TextureLoaderBMP();
        
        textureRAWInfo* loadImageData();
        
};


} // /namespace video

} // /namespace sp


#endif






// ================================================================================
