/*
 * **********************************
 *                                   *
 * HLC Games, Spiele und Software     *
 *                                     *
 * (c) Copyright 2003 - Lukas Hermanns  *
 *                                       *
 * ****************************************
 *  ___    ___    ___          _____
 * /\  \  /\  \  /\  \        /  ___\
 * \ \  \_\_\  \ \ \  \      /\  \__/
 *  \ \   ___   \ \ \  \     \ \  \
 *   \ \  \__/\  \ \ \  \____ \ \  \___
 *    \ \__\ \ \__\ \ \______\ \ \_____\
 *     \/__/  \/__/  \/______/  \/_____/
 *
 * ****************************************
 *
 * ********************** HLC SoftPixelEngine - (3.1.2008) ************************
 *
 * (c) Copyright 2008 - Lukas Hermanns
 *
 * Header for fonts
 *
 */

#ifndef __SP_VIDEODRIVER_FONT_H__
#define __SP_VIDEODRIVER_FONT_H__


#include "spStandard.hpp"
#include "spInputOutputString.hpp"
#include "spDimension.hpp"
#include "spVideoDriverColor.hpp"
#include "spVideoDriverTexture.hpp"


namespace sp
{
namespace video
{


#if defined(WIN32)

class SP_EXPORT Font
{
    
    public:
        
        Font();
        Font(u32 ID, io::stringc FontName, dim::size2di Size, Texture* hTexture, s32 DCFontID, bool is3DSpaceUsing);
        ~Font();
        
        inline u32 getID() const
        {
            return ID_;
        }
        inline dim::size2di getSize() const
        {
            return Size_;
        }
        inline Texture* getTexture() const
        {
            return Texture_;
        }
        inline bool is3DSpaceUsing() const
        {
            return is3DSpaceUsing_;
        }
        
        dim::size2di getStringSize(io::stringc Text) const;
        
    private:
        
        /* Members */
        
        u32 ID_;
        io::stringc FontName_;
        dim::size2di Size_;
        bool is3DSpaceUsing_;
        
        // Texture (for textured font)
        Texture* Texture_;
        
        s32 DCFontID_;
        
};

#elif defined(LINUX)

#endif


} // /namespace video

} // /namespace sp


#endif






// ================================================================================
