/*
 * **********************************
 *                                   *
 * HLC Games, Spiele und Software     *
 *                                     *
 * (c) Copyright 2003 - Lukas Hermanns  *
 *                                       *
 * ****************************************
 *  ___    ___    ___          _____
 * /\  \  /\  \  /\  \        /  ___\
 * \ \  \_\_\  \ \ \  \      /\  \__/
 *  \ \   ___   \ \ \  \     \ \  \
 *   \ \  \__/\  \ \ \  \____ \ \  \___
 *    \ \__\ \ \__\ \ \______\ \ \_____\
 *     \/__/  \/__/  \/______/  \/_____/
 *
 * ****************************************
 *
 * ********************** HLC SoftPixelEngine - (3.1.2008) ************************
 *
 * (c) Copyright 2008 - Lukas Hermanns
 *
 * Header for graphics user interface (GUI)
 *
 */

#ifndef __SP_VIDEODRIVER_GUI_H__
#define __SP_VIDEODRIVER_GUI_H__


#include "spStandard.hpp"
#include "spInputOutputStandard.hpp"
#include "spVideoDriverGUIObjects.hpp"


namespace sp
{
namespace video
{
namespace gui
{


#define __SP_GUIWNDSTD_POS  sp::dim::point2di(-4096, -4096)
#define __SP_GUIWNDSTD_SIZE sp::dim::size2di(-4096, -4096)

#define __SP_GUIWNDSTD_POSADD_COUNT 10

// Sorting functions
bool sortGUIWindows(GUIWindow* &obj1, GUIWindow* &obj2);

class SP_EXPORT GUI
{
    
    public:
        
        GUI();
        ~GUI();
        
        GUIWindow* createWindow(io::stringc Title, dim::point2di Position = __SP_GUIWNDSTD_POS,
                                dim::size2di Size = __SP_GUIWNDSTD_SIZE, s32 Param = 0);
        
        bool deleteWindow(GUIWindow* hWindow);
        
        s32 updateGUIEvent();
        void renderGUI();
        
        // Option functions
        
        void setRasterMode(bool isRasterUsing);
        
        GUIWindow* getFocusedWindow();
        GUIObject* getFocusedObject();
        
    private:
        
        std::list<GUIWindow*> WindowList_;
        GUIWindow* LastFocusedWindow_;
        
};


} // /namespace gui

} // /namespace video

} // /namespace sp


#endif






// ================================================================================
