/*
 * **********************************
 *                                   *
 * HLC Games, Spiele und Software     *
 *                                     *
 * (c) Copyright 2003 - Lukas Hermanns  *
 *                                       *
 * ****************************************
 *  ___    ___    ___          _____
 * /\  \  /\  \  /\  \        /  ___\
 * \ \  \_\_\  \ \ \  \      /\  \__/
 *  \ \   ___   \ \ \  \     \ \  \
 *   \ \  \__/\  \ \ \  \____ \ \  \___
 *    \ \__\ \ \__\ \ \______\ \ \_____\
 *     \/__/  \/__/  \/______/  \/_____/
 *
 * ****************************************
 *
 * ********************** HLC SoftPixelEngine - (3.1.2008) ************************
 *
 * (c) Copyright 2008 - Lukas Hermanns
 *
 * Header for all movie sequence operations
 *
 */

#ifndef __SP_VIDEODRIVER_MOVIEMANAGER_H__
#define __SP_VIDEODRIVER_MOVIEMANAGER_H__


#include "spStandard.hpp"
#include "spInputOutputStandard.hpp"
#include "spVideoDriverTexture.hpp"
#include "spVideoDriverMovie.hpp"

#include <list>


namespace sp
{
namespace video
{
namespace movie
{


enum EMovieStateTypes
{
    MOVIESTATE_STOPED = 0,
    MOVIESTATE_PLAYED,
    MOVIESTATE_PAUSED
};


class SP_EXPORT MovieManager
{
    
    public:
        
        MovieManager();
        ~MovieManager();
        
        Movie* loadMovie(io::stringc Filename, s32 Resolution = 256);
        void closeMovie(Movie* &hMovie);
        
        void playMovie(Movie* hMovie, bool isLoop = false);
        void stopMovie(Movie* hMovie);
        void pauseMovie(Movie* hMovie, bool isPaused = true);
        bool isMovie(Movie* hMovie);
        
        bool isMovieFinished(Movie* hMovie);
        u32 getMovieLength(Movie* hMovie);
        
        void renderMovieTexture(Movie* hMovie, Texture* hTexture);
        
    private:
        
        void flipDataBuffer(void* buffer, u32 Len);
        
};


} // /namespace movie

} // /namespace video

} // /namespace sp


#endif





// ================================================================================
