/*
 * **********************************
 *                                   *
 * HLC Games, Spiele und Software     *
 *                                     *
 * (c) Copyright 2003 - Lukas Hermanns  *
 *                                       *
 * ****************************************
 *  ___    ___    ___          _____
 * /\  \  /\  \  /\  \        /  ___\
 * \ \  \_\_\  \ \ \  \      /\  \__/
 *  \ \   ___   \ \ \  \     \ \  \
 *   \ \  \__/\  \ \ \  \____ \ \  \___
 *    \ \__\ \ \__\ \ \______\ \ \_____\
 *     \/__/  \/__/  \/______/  \/_____/
 *
 * ****************************************
 *
 * ********************** HLC SoftPixelEngine - (3.1.2008) ************************
 *
 * (c) Copyright 2008 - Lukas Hermanns
 *
 * Header for all dimensions
 *
 */

#ifndef __SP_DIMENSION_H__
#define __SP_DIMENSION_H__

/*
 * All dimension classes:
 * (point2d, size2d, rect2d, vector3d, line3d, triangle3d, plane3d, matrix4, quaternion, viewfrustum, array)
 */

#include "spStandard.hpp"

// 2nd dimension
#include "spDimensionPoint2D.hpp"
#include "spDimensionSize2D.hpp"
#include "spDimensionRect2D.hpp"

// 3rd dimension
#include "spDimensionVector3D.hpp"
#include "spDimensionLine3D.hpp"
#include "spDimensionTriangle3D.hpp"
#include "spDimensionPlane3D.hpp"

// matrix arithmetic
#include "spDimensionMatrix4.hpp"

// other dimension classes
#include "spDimensionQuaternion.hpp"
#include "spDimensionViewFrustum.hpp"

// Memory operation class
#include "spDimensionArray.hpp"


#endif





// ================================================================================
