/*
 * **********************************
 *                                   *
 * HLC Games, Spiele und Software     *
 *                                     *
 * (c) Copyright 2003 - Lukas Hermanns  *
 *                                       *
 * ****************************************
 *  ___    ___    ___          _____
 * /\  \  /\  \  /\  \        /  ___\
 * \ \  \_\_\  \ \ \  \      /\  \__/
 *  \ \   ___   \ \ \  \     \ \  \
 *   \ \  \__/\  \ \ \  \____ \ \  \___
 *    \ \__\ \ \__\ \ \______\ \ \_____\
 *     \/__/  \/__/  \/______/  \/_____/
 *
 * ****************************************
 *
 * ********************** HLC SoftPixelEngine - (3.1.2008) ************************
 *
 * (c) Copyright 2008 - Lukas Hermanns
 *
 * Header for model loading TMF-fileformat
 *
 */

#ifndef __SP_MODELLOADER_TMF_H__
#define __SP_MODELLOADER_TMF_H__


#include "spStandard.hpp"
#include "spInputOutputStandard.hpp"
#include "spDimension.hpp"
#include "spVideoDriverTexture.hpp"
#include "spModelLoaderRAW.hpp"


namespace sp
{
namespace scene
{


class SP_EXPORT ModelLoaderTMF : public ModelLoaderRAW
{
    
    public:
        
        ModelLoaderTMF();
        ~ModelLoaderTMF();
        
        Entity* loadModel(io::stringc &Filename, io::stringc &TexturePath);
        
    private:
        
        /* Structures */
        
        struct SSurfaceTMF
        {
            s32 ID;
            s32 MaterialID;
        };
        
        struct SVertexTMF
        {
            dim::vector3df Coord;
            dim::vector3df Normal;
            dim::point2df TexCoord;
        };
        
        /* Functions */
        
        void init();
        void clear();
        
        void loadModelData();
        
        /* Member */
        
        io::FileLoader* hFileLoader_;
        io::File* hFile_;
        
};


} // /namespace scene

} // /namespace sp


#endif





// ================================================================================
