/*
 * **********************************
 *                                   *
 * HLC Games, Spiele und Software     *
 *                                     *
 * (c) Copyright 2003 - Lukas Hermanns  *
 *                                       *
 * ****************************************
 *  ___    ___    ___          _____
 * /\  \  /\  \  /\  \        /  ___\
 * \ \  \_\_\  \ \ \  \      /\  \__/
 *  \ \   ___   \ \ \  \     \ \  \
 *   \ \  \__/\  \ \ \  \____ \ \  \___
 *    \ \__\ \ \__\ \ \______\ \ \_____\
 *     \/__/  \/__/  \/______/  \/_____/
 *
 * ****************************************
 *
 * ********************** HLC SoftPixelEngine - (3.1.2008) ************************
 *
 * (c) Copyright 2008 - Lukas Hermanns
 *
 * Header for model saving OBJ-fileformat
 *
 */

#ifndef __SP_MODELSAVER_OBJ_H__
#define __SP_MODELSAVER_OBJ_H__


#include "spStandard.hpp"
#include "spModelSaverRAW.hpp"


namespace sp
{
namespace scene
{


class SP_EXPORT ModelSaverOBJ : public ModelSaverRAW
{
    
    public:
        
        ModelSaverOBJ();
        ~ModelSaverOBJ();
        
        bool saveModel(Entity* hEntity, io::stringc &Filename);
        
    private:
        
        /* Functions */
        
        void saveModelData();
        
        /* Templates */
        
        template <typename T> void writeValueList(const c8* TypeName, const T* pValueList, const s32 Count)
        {
            FileLoader_->writeStream(hFile_, TypeName, sizeof(c8), strlen(TypeName));
            
            for (s32 i = 0; i < Count; ++i)
            {
                FileLoader_->writeValue<c8>(hFile_, ' ');
                FileLoader_->writeString(hFile_, pValueList[i]);
            }
            
            FileLoader_->writeStringN(hFile_, "");
        }
        
};


} // /namespace scene

} // /namespace sp


#endif





// ================================================================================
