/*
 * **********************************
 *                                   *
 * HLC Games, Spiele und Software     *
 *                                     *
 * (c) Copyright 2003 - Lukas Hermanns  *
 *                                       *
 * ****************************************
 *  ___    ___    ___          _____
 * /\  \  /\  \  /\  \        /  ___\
 * \ \  \_\_\  \ \ \  \      /\  \__/
 *  \ \   ___   \ \ \  \     \ \  \
 *   \ \  \__/\  \ \ \  \____ \ \  \___
 *    \ \__\ \ \__\ \ \______\ \ \_____\
 *     \/__/  \/__/  \/______/  \/_____/
 *
 * ****************************************
 *
 * ********************** HLC SoftPixelEngine - (3.1.2008) ************************
 *
 * (c) Copyright 2008 - Lukas Hermanns
 *
 * Header for the "Ray" core
 *
 */

#ifndef __SP_RAYCORE_H__
#define __SP_RAYCORE_H__


#include <math.h>
#include <stdlib.h>
#include <string.h>


#define __RAY_EXPORT_TO_LIBRARY__
//#define __RAY_EXPORT_WRAPPER__

#ifdef __RAY_EXPORT_TO_LIBRARY__
#   if defined(WIN32)
#       ifdef __RAY_EXPORT_WRAPPER__
#           define RAYAPI extern "C" __declspec(dllexport)
#       else
#           define RAYAPI __declspec(dllexport)
#       endif
#   elif defined(LINUX)
#       define RAYAPI // ???
#   endif
#else
#   define RAYAPI
#endif


/*
 * Compilation options
 */

//#define __RAY_CLAMP_TEXTURESIZE__


/*
 * Typedefinitions
 */

typedef unsigned char   RAYpixel_t;
typedef int             RAYcolor_t;

typedef int             RAYenum;
typedef unsigned int    RAYuint;
typedef unsigned char   RAYubyte;
typedef void            RAYvoid;

typedef bool            RAYboolean;
typedef char            RAYbyte;
typedef short           RAYshort;
typedef int             RAYint;
typedef float           RAYfloat;
typedef double          RAYdouble;



#endif







// ================================================================================
