/*
 * **********************************
 *                                   *
 * HLC Games, Spiele und Software     *
 *                                     *
 * (c) Copyright 2003 - Lukas Hermanns  *
 *                                       *
 * ****************************************
 *  ___    ___    ___          _____
 * /\  \  /\  \  /\  \        /  ___\
 * \ \  \_\_\  \ \ \  \      /\  \__/
 *  \ \   ___   \ \ \  \     \ \  \
 *   \ \  \__/\  \ \ \  \____ \ \  \___
 *    \ \__\ \ \__\ \ \______\ \ \_____\
 *     \/__/  \/__/  \/______/  \/_____/
 *
 * ****************************************
 *
 * ********************** HLC SoftPixelEngine - (3.1.2008) ************************
 *
 * (c) Copyright 2008 - Lukas Hermanns
 *
 * Animator
 *
 */

#include "spSceneManagerAnimator.hpp"


namespace sp
{
namespace scene
{
namespace anim
{


Animator::Animator()
{
}
Animator::~Animator()
{
}

Animation* Animator::addAnimation(Node* hNode)
{
    Animation* Anim = new Animation(hNode);
    AnimObjectList_.push_back(Anim);
    return Anim;
}
Animation* Animator::addAnimation(Entity* hEntity)
{
    Animation* Anim = new Animation(hEntity);
    AnimObjectList_.push_back(Anim);
    return Anim;
}

bool Animator::removeAnimation(Animation* hAnim)
{
    for (std::list<Animation*>::iterator it = AnimObjectList_.begin(); it != AnimObjectList_.end(); ++it)
    {
        if (*it == hAnim)
        {
            AnimObjectList_.erase(it);
            return true;
        }
    }
    return false;
}

void Animator::updateAnimations()
{
    for (std::list<Animation*>::iterator it = AnimObjectList_.begin(); it != AnimObjectList_.end(); ++it)
        (*it)->updateAnimation();
}

Animation* Animator::getAnimation(Node* hNode)
{
    /* Loop for all animations */
    for (std::list<Animation*>::iterator it = AnimObjectList_.begin(); it != AnimObjectList_.end(); ++it)
    {
        if ((*it)->getNode() == hNode || (*it)->getMesh() == hNode)
            return *it;
    }
    
    /* Entity has not been registered */
    return 0;
}


} // /namespace anim

} // /namespace scene

} // /namespace sp







// ================================================================================
