/*
 * **********************************
 *                                   *
 * HLC Games, Spiele und Software     *
 *                                     *
 * (c) Copyright 2003 - Lukas Hermanns  *
 *                                       *
 * ****************************************
 *  ___    ___    ___          _____
 * /\  \  /\  \  /\  \        /  ___\
 * \ \  \_\_\  \ \ \  \      /\  \__/
 *  \ \   ___   \ \ \  \     \ \  \
 *   \ \  \__/\  \ \ \  \____ \ \  \___
 *    \ \__\ \ \__\ \ \______\ \ \_____\
 *     \/__/  \/__/  \/______/  \/_____/
 *
 * ****************************************
 *
 * ********************** HLC SoftPixelEngine - (3.1.2008) ************************
 *
 * (c) Copyright 2008 - Lukas Hermanns
 *
 * Header for the animator
 *
 */

#ifndef __SP_SCENEMANAGER_ANIMATOR_H__
#define __SP_SCENEMANAGER_ANIMATOR_H__


#include "spStandard.hpp"
#include "spSceneManagerEntity.hpp"
#include "spSceneManagerAnimation.hpp"
#include "spDimension.hpp"
#include "spMath.hpp"


namespace sp
{
namespace scene
{
namespace anim
{


class SP_EXPORT Animator
{
    
    public:
        
        Animator();
        ~Animator();
        
        Animation* addAnimation(Node* hNode);
        Animation* addAnimation(Entity* hEntity);
        bool removeAnimation(Animation* hAnim);
        
        void updateAnimations();
        
        Animation* getAnimation(Node* hNode);
        
    private:
        
        std::list<Animation*> AnimObjectList_;
        
};


} // /namespace anim

} // /namespace scene

} // /namespace sp


#endif







// ================================================================================
