/*
 * **********************************
 *                                   *
 * HLC Games, Spiele und Software     *
 *                                     *
 * (c) Copyright 2003 - Lukas Hermanns  *
 *                                       *
 * ****************************************
 *  ___    ___    ___          _____
 * /\  \  /\  \  /\  \        /  ___\
 * \ \  \_\_\  \ \ \  \      /\  \__/
 *  \ \   ___   \ \ \  \     \ \  \
 *   \ \  \__/\  \ \ \  \____ \ \  \___
 *    \ \__\ \ \__\ \ \______\ \ \_____\
 *     \/__/  \/__/  \/______/  \/_____/
 *
 * ****************************************
 *
 * ********************** HLC SoftPixelEngine - (3.1.2008) ************************
 *
 * (c) Copyright 2008 - Lukas Hermanns
 *
 * Sprites
 *
 */

#include "spSceneManagerSprite.hpp"
#include "spMainDevice.hpp"


namespace sp
{

extern video::VideoDriver* __spVideoDriver;

namespace scene
{


Sprite::Sprite() : Node(NODE_SPRITE)
{
    init();
}
Sprite::Sprite(video::Texture* hTexture) : Node(NODE_SPRITE), hTexture_(hTexture)
{
    init();
}
Sprite::~Sprite()
{
}

void Sprite::setBlendingMode(s32 BlendSource, s32 BlendTarget)
{
    Material_.BlendSource = BlendSource;
    Material_.BlendTarget = BlendTarget;
}

/*
 * Rendering
 */

void Sprite::render()
{
    spWorldMatrix.setPosition(Location_);
    
    /* Set the material states */
    __spVideoDriver->setMaterialStatesSprite(Material_);
    
    /* Render the sprite */
    __spVideoDriver->drawSprite(hTexture_, Rotation_.Z, Color_, Scale_, BasePosition_);
}

void Sprite::init()
{
    /* General settings */
    Order_                  = ORDER_NORMAL;
    
    /* Material */
    Material_.BlendSource   = video::BLEND_SRCALPHA;
    Material_.BlendTarget   = video::BLEND_ONE;
}




} // /namespace scene

} // /namespace sp







// ================================================================================
