/*
 * **********************************
 *                                   *
 * HLC Games, Spiele und Software     *
 *                                     *
 * (c) Copyright 2003 - Lukas Hermanns  *
 *                                       *
 * ****************************************
 *  ___    ___    ___          _____
 * /\  \  /\  \  /\  \        /  ___\
 * \ \  \_\_\  \ \ \  \      /\  \__/
 *  \ \   ___   \ \ \  \     \ \  \
 *   \ \  \__/\  \ \ \  \____ \ \  \___
 *    \ \__\ \ \__\ \ \______\ \ \_____\
 *     \/__/  \/__/  \/______/  \/_____/
 *
 * ****************************************
 *
 * ********************** HLC SoftPixelEngine - (3.1.2008) ************************
 *
 * (c) Copyright 2008 - Lukas Hermanns
 *
 * Recordings
 *
 */

#include "spSensitiveSoundRecord.hpp"

#if defined(WIN32)
#   include <windows.h>
#   include <mmsystem.h>
#endif


namespace sp
{
namespace sound
{


Record::Record() : isRecording_(false)
{
    static u32 RecordCounter;
    
    ID_ = ++RecordCounter;
    
    memset(RecBuffer_, 0, sizeof(RecBuffer_));
}
Record::~Record()
{
}

#if defined(WIN32)

void Record::beginRecording()
{
    mciSendString(
        io::stringc( io::stringc("open new type waveaudio alias RECORD") + io::stringc(ID_) ).c_str(),
        RecBuffer_, DEF_RECORD_BUFFERSIZE, 0
    );
    mciSendString(
        io::stringc(
            io::stringc("set RECORD") + io::stringc(ID_) + io::stringc(" samplesperbuffer 8000 bytesperbuffer 8000")
        ).c_str(),
        0, 0, 0
    );
    mciSendString(
        io::stringc(io::stringc("record RECORD")+io::stringc(ID_)).c_str(),
        RecBuffer_, DEF_RECORD_BUFFERSIZE, 0
    );
    isRecording_ = true;
}

void Record::endRecording()
{
    mciSendString(
        io::stringc( io::stringc("stop RECORD") + io::stringc(ID_) ).c_str(), 0, 0, 0
    );
    isRecording_ = false;
}

void Record::saveRecord(io::stringc Filename)
{
    mciSendString(
        io::stringc( io::stringc("save RECORD") + io::stringc(ID_) + io::stringc(" \"") + Filename + io::stringc("\"") ).c_str(),
        RecBuffer_, DEF_RECORD_BUFFERSIZE, 0
    );
}

#elif defined(LINUX)

#endif


} // /namespace sound

} // /namespace sp







// ================================================================================
