/*
 * **********************************
 *                                   *
 * HLC Games, Spiele und Software     *
 *                                     *
 * (c) Copyright 2003 - Lukas Hermanns  *
 *                                       *
 * ****************************************
 *  ___    ___    ___          _____
 * /\  \  /\  \  /\  \        /  ___\
 * \ \  \_\_\  \ \ \  \      /\  \__/
 *  \ \   ___   \ \ \  \     \ \  \
 *   \ \  \__/\  \ \ \  \____ \ \  \___
 *    \ \__\ \ \__\ \ \______\ \ \_____\
 *     \/__/  \/__/  \/______/  \/_____/
 *
 * ****************************************
 *
 * ********************** HLC SoftPixelEngine - (3.1.2008) ************************
 *
 * (c) Copyright 2008 - Lukas Hermanns
 *
 * Sounds
 *
 */

#include "spSensitiveSoundSound.hpp"

#if defined(WIN32)
#   include <windows.h>
#   include <mmsystem.h>
#endif


namespace sp
{
namespace sound
{


Sound::Sound()
{
    init();
}
Sound::Sound(io::stringc Filename, u8 Quality, u8 Count)
{
    static u32 CountID;
    
    init();
    
    ID_         = CountID;
    Count_      = Count;
    Filename_   = Filename;
    Quality_    = Quality == SOUNDQUALITY_IGNORE ? SOUNDQUALITY_HIGH : Quality;
    CountID     += Count;
}
Sound::~Sound()
{
}

void Sound::addIDCount()
{
    if (++CurID_ >= Count_)
        CurID_ = 0;
}

void Sound::useSubSound(u32 Nr)
{
    if (Nr >= 0 && Nr < Count_)
        CurID_ = Nr;
}


/*
 * ======= Private: =======
 */

void Sound::init()
{
    ID_             = 0;
    CurID_          = 0;
    Count_          = DEF_SOUND_LAYERCOUNT;
    Filename_       = "";
    Position_       = dim::vector3df(0.0f);
    isPaused_       = false;
    isLooped_       = false;
    isVolumetric_   = false;
}


} // /namespace sound

} // /namespace sp







// ================================================================================
