/*
 * **********************************
 *                                   *
 * HLC Games, Spiele und Software     *
 *                                     *
 * (c) Copyright 2003 - Lukas Hermanns  *
 *                                       *
 * ****************************************
 *  ___    ___    ___          _____
 * /\  \  /\  \  /\  \        /  ___\
 * \ \  \_\_\  \ \ \  \      /\  \__/
 *  \ \   ___   \ \ \  \     \ \  \
 *   \ \  \__/\  \ \ \  \____ \ \  \___
 *    \ \__\ \ \__\ \ \______\ \ \_____\
 *     \/__/  \/__/  \/______/  \/_____/
 *
 * ****************************************
 *
 * ********************** HLC SoftPixelEngine - (3.1.2008) ************************
 *
 * (c) Copyright 2008 - Lukas Hermanns
 *
 * All global variables, constants ...
 *
 */

#include "spStandard.hpp"
#include "spOpenGLFunctionsARB.hpp"


namespace sp
{


/*
 * Internal global members
 */

s32 __Screen_Width       = __SP_STD_SCREEN_WIDTH;
s32 __Screen_Height      = __SP_STD_SCREEN_HEIGHT;
s32 __Screen_ColorDepth  = 16;

bool __isKey[__SP_KEYCODE_COUNT], __wasKey[__SP_KEYCODE_COUNT], __hitKey[__SP_KEYCODE_COUNT];
bool __isMouseKey[__SP_MOUSEKEY_COUNT], __wasMouseKey[__SP_MOUSEKEY_COUNT], __hitMouseKey[__SP_MOUSEKEY_COUNT];

s32 __CursorSpeedX = 0, __CursorSpeedY = 0, __MouseWheel = 0;

bool __isLighting = false, __isFog = false;



/*
 * OpenGL extendet functions
 */


// OpenGL extendet functions (glext.h)

PFNGLMULTITEXCOORD2FARBPROC             glMultiTexCoord2fARB            = 0;
PFNGLACTIVETEXTUREARBPROC               glActiveTextureARB              = 0;
PFNWGLCHOOSEPIXELFORMATARBPROC          wglChoosePixelFormatARB         = 0;
PFNWGLSWAPINTERVALFARPROC               wglSwapIntervalEXT              = 0;
//PFNGLACTIVESTENCILFACEEXTPROC           glActiveStencilFaceEXT          = 0;
PFNGLTEXIMAGE3DEXTPROC                  glTexImage3DEXT                 = 0;

// VBO extension function pointers

PFNGLCLIENTACTIVETEXTUREARBPROC         glClientActiveTextureARB        = 0;
PFNGLFOGCOORDPOINTERPROC                glFogCoordPointer               = 0;

PFNGLGENBUFFERSARBPROC                  glGenBuffersARB                 = 0;
PFNGLBINDBUFFERARBPROC                  glBindBufferARB                 = 0;
PFNGLBUFFERDATAARBPROC                  glBufferDataARB                 = 0;
PFNGLDELETEBUFFERSARBPROC               glDeleteBuffersARB              = 0;

// Shader (GLSL)

PFNGLBINDPROGRAMARBPROC                 glBindProgramARB                = 0;
PFNGLPROGRAMSTRINGARBPROC               glProgramStringARB              = 0;
PFNGLGENPROGRAMSARBPROC                 glGenProgramsARB                = 0;
PFNGLDELETEPROGRAMSARBPROC              glDeleteProgramsARB             = 0;
PFNGLPROGRAMLOCALPARAMETER4FVARBPROC    glProgramLocalParameter4fvARB   = 0;

PFNGLDELETEPROGRAMPROC                  glDeleteProgram                 = 0;
PFNGLDELETESHADERPROC                   glDeleteShader                  = 0;
PFNGLCREATEPROGRAMOBJECTARBPROC         glCreateProgramObjectARB        = 0;
PFNGLCREATESHADEROBJECTARBPROC          glCreateShaderObjectARB         = 0;
PFNGLSHADERSOURCEARBPROC                glShaderSourceARB               = 0;
PFNGLCOMPILESHADERARBPROC               glCompileShaderARB              = 0;
PFNGLATTACHOBJECTARBPROC                glAttachObjectARB               = 0;
PFNGLDELETEOBJECTARBPROC                glDeleteObjectARB               = 0;
PFNGLLINKPROGRAMARBPROC                 glLinkProgramARB                = 0;
PFNGLUSEPROGRAMOBJECTARBPROC            glUseProgramObjectARB           = 0;
PFNGLGETOBJECTPARAMETERIVARBPROC        glGetObjectParameterivARB       = 0;
PFNGLGETINFOLOGARBPROC                  glGetInfoLogARB                 = 0;
PFNGLDETACHOBJECTARBPROC                glDetachObjectARB               = 0;
PFNGLGETACTIVEUNIFORMARBPROC            glGetActiveUniformARB           = 0;
PFNGLUNIFORM1FARBPROC                   glUniform1fARB                  = 0;
PFNGLUNIFORM3FARBPROC                   glUniform3fARB                  = 0;
PFNGLUNIFORM4FARBPROC                   glUniform4fARB                  = 0;
PFNGLUNIFORM1IARBPROC                   glUniform1iARB                  = 0;
PFNGLUNIFORM1IVARBPROC                  glUniform1ivARB                 = 0;
PFNGLUNIFORM1FVARBPROC                  glUniform1fvARB                 = 0;
PFNGLUNIFORM2FVARBPROC                  glUniform2fvARB                 = 0;
PFNGLUNIFORM3FVARBPROC                  glUniform3fvARB                 = 0;
PFNGLUNIFORM4FVARBPROC                  glUniform4fvARB                 = 0;
PFNGLUNIFORMMATRIX2FVARBPROC            glUniformMatrix2fvARB           = 0;
PFNGLUNIFORMMATRIX3FVARBPROC            glUniformMatrix3fvARB           = 0;
PFNGLUNIFORMMATRIX4FVARBPROC            glUniformMatrix4fvARB           = 0;


} // /namespace sp







// ================================================================================
