/*
 * **********************************
 *                                   *
 * HLC Games, Spiele und Software     *
 *                                     *
 * (c) Copyright 2003 - Lukas Hermanns  *
 *                                       *
 * ****************************************
 *  ___    ___    ___          _____
 * /\  \  /\  \  /\  \        /  ___\
 * \ \  \_\_\  \ \ \  \      /\  \__/
 *  \ \   ___   \ \ \  \     \ \  \
 *   \ \  \__/\  \ \ \  \____ \ \  \___
 *    \ \__\ \ \__\ \ \______\ \ \_____\
 *     \/__/  \/__/  \/______/  \/_____/
 *
 * ****************************************
 *
 * ********************** HLC SoftPixelEngine - (3.1.2008) ************************
 *
 * (c) Copyright 2008 - Lukas Hermanns
 *
 * Header for texture loading JPG-fileformat
 *
 */

#ifndef __SP_TEXTURELOADER_JPG_H__
#define __SP_TEXTURELOADER_JPG_H__


#include "spStandard.hpp"
#include "spTextureManager.hpp"

struct jpeg_decompress_struct;


namespace sp
{
namespace video
{


class SP_EXPORT TextureLoaderJPG : public TextureLoaderRAW
{
    
    public:
        
        TextureLoaderJPG(io::stringc &Filename);
        ~TextureLoaderJPG();
        
        textureRAWInfo* loadImageData();
        
    private:
        
        /* Functions */
        
        bool checkForError();
        
        void decompressJPG(jpeg_decompress_struct* cInfo, textureRAWInfo* TextureInfo);
        
};


} // /namespace video

} // /namespace sp


#endif






// ================================================================================
