/*
 * **********************************
 *                                   *
 * HLC Games, Spiele und Software     *
 *                                     *
 * (c) Copyright 2003 - Lukas Hermanns  *
 *                                       *
 * ****************************************
 *  ___    ___    ___          _____
 * /\  \  /\  \  /\  \        /  ___\
 * \ \  \_\_\  \ \ \  \      /\  \__/
 *  \ \   ___   \ \ \  \     \ \  \
 *   \ \  \__/\  \ \ \  \____ \ \  \___
 *    \ \__\ \ \__\ \ \______\ \ \_____\
 *     \/__/  \/__/  \/______/  \/_____/
 *
 * ****************************************
 *
 * ********************** HLC SoftPixelEngine - (3.1.2008) ************************
 *
 * (c) Copyright 2008 - Lukas Hermanns
 *
 * Header for movies
 *
 */

#ifndef __SP_VIDEODRIVER_MOVIE_H__
#define __SP_VIDEODRIVER_MOVIE_H__


#include "spStandard.hpp"
#include "spDimensionSize2D.hpp"
#include "spInputOutputString.hpp"


namespace sp
{
namespace video
{
namespace movie
{


class SP_EXPORT Movie
{
    
    public:
        
        Movie();
        Movie(io::stringc Filename, s32 DataPointer);
        ~Movie();
        
        /* Functions */
        
        dim::size2di getSize() const;
        
        /* Inline functions */
        
        inline io::stringc getFilename() const
        {
            return Filename_;
        }
        
        inline s32 &getSequenceData()
        {
            return DataPointer_;
        }
        
    private:
        
        /* Members */
        
        s32 DataPointer_;
        io::stringc Filename_;
        
};


} // /namespace movie

} // /namespace video

} // /namespace sp


#endif






// ================================================================================
