/*
 * **********************************
 *                                   *
 * HLC Games, Spiele und Software     *
 *                                     *
 * (c) Copyright 2003 - Lukas Hermanns  *
 *                                       *
 * ****************************************
 *  ___    ___    ___          _____
 * /\  \  /\  \  /\  \        /  ___\
 * \ \  \_\_\  \ \ \  \      /\  \__/
 *  \ \   ___   \ \ \  \     \ \  \
 *   \ \  \__/\  \ \ \  \____ \ \  \___
 *    \ \__\ \ \__\ \ \______\ \ \_____\
 *     \/__/  \/__/  \/______/  \/_____/
 *
 * ****************************************
 *
 * ********************** HLC SoftPixelEngine - (3.1.2008) ************************
 *
 * (c) Copyright 2008 - Lukas Hermanns
 *
 * Header for texture manipulator
 *
 */

#ifndef __SP_VIDEODRIVER_TEXTUREMANIPULATOR_H__
#define __SP_VIDEODRIVER_TEXTUREMANIPULATOR_H__


#include "spStandard.hpp"
#include "spDimension.hpp"
#include "spVideoDriverColor.hpp"
#include "spVideoDriverTexture.hpp"
#include "spMath.hpp"


namespace sp
{
namespace video
{
namespace effect
{


#define __SP_TEXMANIP_RECTIGNORE    dim::rect2di(-1, -1, -1, -1)


class SP_EXPORT TextureManipulator
{
    
    public:
        
        TextureManipulator();
        ~TextureManipulator();
        
        void renderMosaic(Texture* &hTexture, s32 PixelSize, dim::rect2di Rect = __SP_TEXMANIP_RECTIGNORE);
        
        void renderBlur(Texture* &hTexture, s32 PixelSize, dim::rect2di Rect = __SP_TEXMANIP_RECTIGNORE);
        
    private:
        
        void checkCorrectDimensions(Texture* hTexture, dim::rect2di &Rect);
        
};


} // /namespace effect
    
} // /namespace video

} // /namespace sp


#endif






// ================================================================================
